#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../../Stage/RandomBG.txt"]
#System["./../../../../../ds_system/S_System.txt"]

#include"./../../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss1.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimation_UtsuhoA1(Enemy);
	SetInvincibility(Enemy, 210, 85, 75);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(424);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
	
		
		let face = GetCurrentScriptDirectory~"face/";
		
		ObjCutin_SetSpellcardM4("Keystone \"something\"", 3500000, "JOON", face~"spell_use_cut.png", 96, 144, 255);
		ObjCutin_AddUVTOffsetA1(-32, 0);
		
		ObjCutin_SetSpellcardM4("something \"something\"", 3500000, "SHION", face~"spell_use_cut (2).png", 255, 96, 16);
		ObjCutin_AddUVTOffsetA1(-144, 164);
		
		PlaySoundO1(spell_0);
		
		yield;
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 7, 6);
		ObjEnemyBossScene_StartSpell(objScene);
		
		
		let espd = 1.2+argument/52;
		let aspd = 3.6;
		
		Hold(90);
		let dir = rand(0,360);
		
		let ox = EnemyX;
		let oy = EnemyY;
		let test = 0;
		
		
		argument = 48;
		
		SetUpNukeRenders;
		Sunnon;
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			
			if(!Hold(150)){break;}
		}
	}
}

task NukeFire(X){
	let sc = 0.2;
	let a = CreateLargeNukeA1(X, -50);
	Obj_SetValue(a, "NukeScale", sc);
	Obj_SetValue(a, "NukeHitbox", false);
	ObjMove_SetSpeed(a,0.75);
	ObjMove_SetAngle(a,90);
	if(!Hold(2)){break;}
	loop(15){
		Obj_SetValue(a, "NukeScale", sc);
		sc+=1.7/15;
	if(!Hold(1)){break;}
	}
	ring(a,150);
}

task Sunnon {
	if(!Hold(100)){break;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		NukeFire(GetStgFrameWidth/4);
		if(!Hold(280)){break;}
		NukeFire(GetStgFrameWidth/4*3);
		if(!Hold(280)){break;}
	}
	
}

task ring(obj,rad){
	let dir = rand(0,360);
	let X = ObjMove_GetX(obj);
	let Y = ObjMove_GetY(obj);
	loop(24){
		let a = CreateObjShotA1(X+rad*cos(dir),Y-rad*sin(dir),0.75,90,10,0);
		ObjShot_SetAutoDelete(a,false);
		ObjShot_SetSpellResist(a,true);
		ObjShot_SetDeleteFrame(a, 840);
		dir+=360/24;
	}
}