#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Utsuho Nonspell 4"]
#Background["./../../../../Stage/RandomBG.txt"]
#System["./../../../../../ds_system/S_System.txt"]

#include"./../../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss1.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(45-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimation_UtsuhoA1(Enemy);
	SetInvincibility(Enemy, 90, 165, 40);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(45);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
	
		
		
		yield;
		// ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 7, 6);
		// ObjEnemyBossScene_StartSpell(objScene);
		
		
		let espd = 1.2+argument/52;
		let aspd = 3.6;
		
		Hold(75);
		let dir = rand(0,360);
		
		let ox = EnemyX;
		let oy = EnemyY;
		let test = 0;
		
		
		argument = 48;
		
		let argi = 50;
		
		
		WarningRender = InitRender(EnemyRender, 0.37, current~"warning_zun.png");
		ObjSpriteList2D_SetSourceRect(WarningRender, 64, 0, 96, 32);
		ObjSpriteList2D_SetDestCenter(WarningRender);
		ObjRender_SetBlendType(WarningRender, BLEND_ADD_ARGB);
		
		
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2-GetStgFrameWidth/3, GetStgFrameHeight/3, 7, 6);
		while(ObjMove_GetSpeed(Enemy) > 0.2){if(!Hold(5)){break;}}
		if(!Hold(15)){return;}
		ObjMove_SetAngle(Enemy, 90+28);
		ObjMove_SetSpeed(Enemy, 1.5*1.43);
		ObjMove_SetMaxSpeed(Enemy, 11);
		ObjMove_SetAcceleration(Enemy, 0.1*1.43);
		ObjMove_SetAngularVelocity(Enemy, -137/35);
		if(!Hold(35)){return;}
		ObjMove_SetAcceleration(Enemy, 0.3);
		ObjMove_SetAngularVelocity(Enemy, 0);
		HoldForTilOutside(Enemy);
		
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			
			// UtsuhoColumnsA2(Enemy,150,26,3);
			// UtsuhoColumnsA1(Enemy,450,20,4);
			
			ascent(x in 0..3){
				ascent(i in 0..2){
					let lmod = 1-2*i;
					
					
					ObjMove_SetX(Enemy, GetStgFrameWidth/2+GetStgFrameWidth/1.7*lmod);
					ObjMove_SetY(Enemy, GetStgFrameHeight/2-48 + rand(-32, 32));
					ObjMove_SetAngle(Enemy, 90+100*lmod);
					// ObjMove_SetSpeed(Enemy, 10);
					
					if(!Hold(30)){break;}
					
					alternative(x*2+i)
					case(0){UtsuhoColumnsA1(Enemy,25,5,10);}
					case(1){UtsuhoColumnsA2(Enemy,25,20,2);}
					case(2){UtsuhoColumnsA3(Enemy,25,5,10);}
					case(3){UtsuhoColumnsA1(Enemy,25,5,10);}
					case(4){UtsuhoColumnsA2(Enemy,25,20,2);}
					case(5){UtsuhoColumnsA3(Enemy,25,5,10);}
					
					HoldForTilOutside(Enemy);
					
				}
				if(!Hold(1)){break;}
			}
			

			if(!Hold(1)){break;}
		}
	}
}

function SendOff(obj, lmod){
	ObjMove_SetDestAtWeight(obj, GetStgFrameWidth/2-GetStgFrameWidth/3*lmod, GetStgFrameHeight/5.5, 7, 6);
	
	while(ObjMove_GetSpeed(obj) > 0.2){if(!Hold(10)){break;}}
	if(!Hold(10)){return;}
	
	ObjMove_SetAngle(obj, 90+28*lmod);
	ObjMove_SetSpeed(obj, 1.5);
	ObjMove_SetMaxSpeed(obj, 11);
	ObjMove_SetAcceleration(obj, 0.1);
	ObjMove_SetAngularVelocity(obj, -137*lmod/50);
	if(!Hold(50)){return;}
	ObjMove_SetAcceleration(obj, 0.3);
	ObjMove_SetAngularVelocity(obj, 0);
	
	HoldForTilOutside(obj);
	
	ObjMove_SetY(obj, ObjMove_GetY(obj)+212);
	ObjMove_SetAngle(obj, 90+100*lmod);
	ObjMove_SetSpeed(obj, 10);
	
	if(!Hold(60)){return;}
	
	HoldForTilOutside(obj);
}

function HoldForTilOutside(obj){
	while(ObjMove_GetX(obj) > -80 && ObjMove_GetX(obj) < GetStgFrameWidth+80){if(!Hold(1)){break;}}
	if(!Hold(5)){return;}
	// ObjMove_SetSpeed(obj, 0);
	// ObjMove_SetAcceleration(obj, 0);
	// ObjMove_SetAngularVelocity(obj, 0);
}

task UtsuhoColumnsA1(obj,w,numb,rate){
	if(!Hold(w)){return;}
	ascent(i in 0..numb){
		UtsuhoColumnA1(obj,ObjMove_GetAngle(obj)+90+rand(-6,6));
		if(!Hold(rate)){break;}
	}
}

task UtsuhoColumnsA2(obj,w,numb,rate){
	if(!Hold(w)){return;}
	ascent(i in 0..numb){
		UtsuhoColumnA2(obj);
		if(!Hold(rate)){break;}
	}
}

task UtsuhoColumnsA3(obj,w,numb,rate){
	if(!Hold(w)){return;}
	let dir = rand(0,360);
	ascent(i in 0..numb){
		UtsuhoColumnA3(obj,dir);
		dir+=360/numb*2;
		if(!Hold(rate)){break;}
	}
}

task UtsuhoColumnA1(obj,dir){
	let X = ObjMove_GetX(obj);
	let Y = ObjMove_GetY(obj);
	let Bspd = 0.1;
	let dcount = 2;
	let dcirc = 360/dcount;
	ascent(x in 0..dcount){
		let Udir = dir+x*dcirc;
		ascent(i in 1..7){
			let mspd = Bspd+0.2+(i*0.8);
			let a = CreateBirdShotA2(X+30*cos(Udir),Y+30*sin(Udir),Bspd+(i*0.1),Udir,mspd/(30+i),mspd,173,35-i);
			ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
		}
	}
}

task UtsuhoColumnA2(obj){
	let X = ObjMove_GetX(obj);
	let Y = ObjMove_GetY(obj);
	let Bspd = 0.1;
	let dcount = 2;
	let dcirc = 360/dcount;
	ascent(x in 0..dcount){
		let Udir = AngleToPlayer(X,Y)+x*dcirc;
		ascent(i in 2..7){
			let mspd = Bspd+0.2+(i*0.8);
			let a = CreateBirdShotA2(X+30*cos(Udir),Y+30*sin(Udir),Bspd+(i*0.1),Udir,mspd/(30+i),mspd,161,35-i);
			ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
			//ObjShot_SetDeleteFrame(a, 150);
		}
	}
}

task UtsuhoColumnA3(obj,dir){
	let X = ObjMove_GetX(obj);
	let Y = ObjMove_GetY(obj);
	let Bspd = 0.1;
	let dcount = 2;
	let dcirc = 360/dcount;
		ascent(x in 0..dcount){
		let Udir = 90+x*dcirc;
		ascent(i in 1..7){
			let mspd = Bspd+0.2+(i*0.8);
			let a = CreateBirdShotA2(X+30*cos(Udir),Y+30*sin(Udir),Bspd+(i*0.1),Udir,mspd/(30+i),mspd,171,35-i);
			ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
			
		}
	}
}