
#include"./../../../../../ds_system/library/Anim/AnimLib.h"

task SetEnemyAnimation_UtsuhoA1(Enemy){
	
	let xc = 96;
	let yc = 96;
	let l = -1;
	
	
	l = 0;
	ascent(i in 0..4){ObjAnim_AddFrameA1(Enemy, ANIM_IDLE, xc*i, yc*l, xc*(i+1), yc*(l+1));}
	
	l = 1;
	ascent(i in 0..3){ObjAnim_AddFrameA1(Enemy, ANIM_MOVE_RIGHT, xc*i, yc*l, xc*(i+1), yc*(l+1));}
	descent(i in 0..3){ObjAnim_AddFrameA1(Enemy, ANIM_MOVEEND_RIGHT, xc*i, yc*l, xc*(i+1), yc*(l+1));}

	l = 2;
	ascent(i in 0..3){ObjAnim_AddFrameA1(Enemy, ANIM_MOVE_LEFT, xc*i, yc*l, xc*(i+1), yc*(l+1));}
	descent(i in 0..3){ObjAnim_AddFrameA1(Enemy, ANIM_MOVEEND_LEFT, xc*i, yc*l, xc*(i+1), yc*(l+1));}

	l = 3;
	ascent(i in 0..4){ObjAnim_AddFrameA1(Enemy, ANIM_ATTACK, xc*i, yc*l, xc*(i+1), yc*(l+1));}
	descent(i in 0..4){ObjAnim_AddFrameA1(Enemy, ANIM_ATTACKEND, xc*i, yc*l, xc*(i+1), yc*(l+1));}
	
	
	ObjAnim_SetLoopPointA1(Enemy, ANIM_MOVE_RIGHT, 2);
	ObjAnim_SetLoopPointA1(Enemy, ANIM_MOVE_LEFT, 2);
	ObjAnim_SetLoopPointA1(Enemy, ANIM_ATTACK, 2);
	ObjAnim_SetSpeedA1(Enemy, ANIM_IDLE, 10);
	ObjAnim_SetSpeedA1(Enemy, ANIM_MOVE_RIGHT, 6);
	ObjAnim_SetSpeedA1(Enemy, ANIM_MOVE_LEFT, 6);
	ObjAnim_SetSpeedA1(Enemy, ANIM_ATTACK, 6);
	ObjAnim_SetSpeedA1(Enemy, ANIM_ATTACKEND, 9);
	ObjAnim_StartAnimationFA2(Enemy, "Utsuho", 5, 1.75);
	
	
	
	
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriority(obj, 0.45);
	ObjPrim_SetTexture(obj, GetCurrentScriptDirectory~"boss1.png");
	ObjRender_SetAlpha(obj, 255);
	ObjSprite2D_SetSourceRect(obj, 288, 96, 480, 288);
	ObjSprite2D_SetDestCenter(obj);
	let tick = 0;
	let active = false;
	let scale = 0;
	let col = 234;
	let oang = 110;
	while(!Obj_IsDeleted(Enemy)){
		ObjRender_SetPosition(obj, ObjMove_GetX(Enemy)-2, ObjMove_GetY(Enemy)-34, 0);
		tick++;
		if(tick%4 < 2){
			oang -= 193;
			ObjRender_SetColor(obj, 234, 64, 108);
		}else{
			oang -= 180;
			ObjRender_SetColor(obj, 234, 192, 32);
		}
		if(ObjAnim_IsAttackPlaying(Enemy)){
			scale = min(scale+0.02, 1);
		}else{
			scale = 0;
		}
			ObjRender_SetAngleZ(obj, oang);
		let rscl = truncate(scale*20)/20;
		ObjRender_SetScaleXYZ(obj, rscl, rscl, rscl);
		yield;
	}
	Obj_Delete(obj);
}


task SetEnemyAnimation_Tenshi(objEnemy){
	
	if(GetScriptArgumentCount == 0){
		LoadEnemyShotData(GetCurrentScriptDirectory~"TenshiShot.txt");
	}
	let xc = 64;
	let yc = 80;

	let l = -1;
	
	
	l = 0;
	ascent(i in 0..4){ObjAnim_AddFrameA2(objEnemy, ANIM_IDLE, xc*i, yc*(l), xc*(i+1), yc*(l+1), 0, 0);}
	descent(i in 1..3){ObjAnim_AddFrameA2(objEnemy, ANIM_IDLE, xc*i, yc*(l), xc*(i+1), yc*(l+1), 0, 0);}
	
	l = 1;
	ascent(i in 0..4){ObjAnim_AddFrameA2(objEnemy, ANIM_MOVE, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}
	descent(i in 0..3){ObjAnim_AddFrameA2(objEnemy, ANIM_MOVEEND, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}
	
	l = 2;
	ascent(i in 0..4){ObjAnim_AddFrameA2(objEnemy, ANIM_ATTACK, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}
	l = 3;
	ascent(i in 0..1){ObjAnim_AddFrameA2(objEnemy, ANIM_ATTACK, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}
	ascent(i in 0..1){ObjAnim_AddFrameA2(objEnemy, ANIM_ATTACKEND, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}

	
	
	
	
	ObjAnim_SetLoopPointA1(objEnemy, ANIM_MOVE, 3);
	ObjAnim_SetLoopPointA1(objEnemy, ANIM_MOVE, 3);
	ObjAnim_SetLoopPointA1(objEnemy, ANIM_ATTACK, 4);
	ObjAnim_SetSpeedA1(objEnemy, ANIM_IDLE, 8);
	ObjAnim_SetSpeedA1(objEnemy, ANIM_MOVE, 6);
	ObjAnim_SetSpeedA1(objEnemy, ANIM_ATTACK, 6);
	// ObjAnim_SetNoMoveAnim(objEnemy, true);
	ObjAnim_StartAnimationFA1(objEnemy, "Tenshi", 5, 1.75);
	
	SetEnemyAnimation_Seija(objEnemy);
}
task SetEnemyAnimation_Seija(objEnemy){


	let xc = 64;
	let yc = 80;

	let l = -1;
	
	
	l = 0;
	ascent(i in 0..4){ObjAnim_AddFrameA2(objEnemy, ANIM_IDLE, xc*i, yc*(l), xc*(i+1), yc*(l+1), 0, 0);}
	descent(i in 1..3){ObjAnim_AddFrameA2(objEnemy, ANIM_IDLE, xc*i, yc*(l), xc*(i+1), yc*(l+1), 0, 0);}
	
	l = 1;
	ascent(i in 0..8){ObjAnim_AddFrameA2(objEnemy, ANIM_MOVE_RIGHT, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}
	descent(i in 0..6){ObjAnim_AddFrameA2(objEnemy, ANIM_MOVEEND_RIGHT, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}
	
	l = 2;
	ascent(i in 0..6){ObjAnim_AddFrameA2(objEnemy, ANIM_MOVE_LEFT, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}
	descent(i in 0..6){ObjAnim_AddFrameA2(objEnemy, ANIM_MOVEEND_LEFT, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}
	
	l = 3;
	ascent(i in 0..8){ObjAnim_AddFrameA2(objEnemy, ANIM_ATTACK, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}
	descent(i in 0..4){ObjAnim_AddFrameA2(objEnemy, ANIM_ATTACKEND, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}
	l = 3;
	ascent(i in 0..1){ObjAnim_AddFrameA2(objEnemy, ANIM_ATTACKEND, xc*i, yc*l, xc*(i+1), yc*(l+1), 0, 0);}

	
	
	
	
	ObjAnim_SetLoopPointA1(objEnemy, ANIM_MOVE_RIGHT, 6);
	ObjAnim_SetLoopPointA1(objEnemy, ANIM_MOVE_LEFT, 5);
	ObjAnim_SetLoopPointA1(objEnemy, ANIM_ATTACK, 3);
	ObjAnim_SetSpeedA1(objEnemy, ANIM_IDLE, 8);
	ObjAnim_SetSpeedA1(objEnemy, ANIM_MOVE, 6);
	ObjAnim_SetSpeedA1(objEnemy, ANIM_ATTACK, 6);
	// ObjAnim_SetNoMoveAnim(objEnemy, true);
	ObjAnim_StartAnimationFA2(objEnemy, "Seija", 5, 1.75);
	ObjAnim_SetAnimationPauseA1(objEnemy, "Seija", true);
}


