#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Utsuho Spell 3"]
#Background["./../../../../Stage/RandomBG.txt"]
#System["./../../../../../ds_system/S_System.txt"]

#include"./../../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss1.png"; 
let imgEnemy2 = current~"boss1i.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(1);}
	case(EV_REQUEST_TIMER){SetScriptResult(38-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy2, 0, 0, 512, 512);
	SetEnemyAnimation_UtsuhoA1(Enemy);
	SetInvincibility(Enemy, 210, 0, 0);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		// ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		// ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(38);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
	
		
		let face = GetCurrentScriptDirectory~"face/";
		
		ObjCutin_SetSpellcardM4("\"Nuclear Defusion\"", 3500000, "BYAKUREN", face~"spell_use_cut.png", 96, 144, 255);
		
		PlaySoundO1(spell_0);
		
		yield;
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 7, 6);
		ObjEnemyBossScene_StartSpell(objScene);
		
		
		let espd = 1.2+argument/52;
		let aspd = 3.6;
		
		Hold(90);
		let dir = rand(0,360);
		
		let ox = EnemyX;
		let oy = EnemyY;
		let test = 0;
		
		
		// argument = 48;
		
		SetUpNukeRenders;
		
		let argd = 56+argument;
		let argys = 200-argument*0.9;
		
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			
			// ObjAnim_SetAttackA2(Enemy, 470);
			
			
			// ascent(i in 0..2){
				// let lmod = 1-2*i;
				
				// ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2-GetStgFrameWidth/3*lmod, GetStgFrameHeight/5.5, 7, 6);
				// while(ObjMove_GetSpeed(Enemy) > 0.1){if(!Hold(25)){break;}}
				
				
				// ascent(i in 0..2){
				
				
				// }
			// }
			

			let obang = GetAngleToPlayer(Enemy);
			
			let tx = EnemyX+argd*cos(obang);
			let ty = EnemyY+argd*sin(obang);
			
			obang += 360/6*round(rand(0, 6));
			
			ascent(i in 0..5){
				let a = CreateFakeUtsuhoA2(imgEnemy2, EnemyX, EnemyY);
				Obj_SetValue(a, "EnemyDefaults", false);
				Obj_SetValue(a, "DoShaderEffect", false);
				// Obj_SetValue(a, "HitboxType", 2);
				ObjRender_SetAlpha(a, 255);
				ObjRender_SetColor(a, 255, 255, 255);
				ClampUtsuhoToPoint(a, 28, 10, obang+360/6*i, 22, tx, ty, 0);
			}
			PlaySoundO2(se_kira02, 40);
			ClampUtsuhoToPoint(Enemy, 28, 10, obang+-360/6, 22, tx, ty, argys*2);
			if(!Hold(argys)){break;}
			argys = max(argys-7, 60);
		}
		
		
		task ClampUtsuhoToPoint(obj, duration, bspd, ang, bdure, x, y, implode){
				let ox = ObjMove_GetX(obj);
				let oy = ObjMove_GetY(obj);
		
				ObjMove_SetMaxSpeed(obj, 0);
				ObjMove_SetAngle(obj, ang);
				ObjMove_SetSpeed(obj, bspd);
				ObjMove_SetAcceleration(obj, -bspd/bdure);
				
				if(!Hold(duration)){return;}
				
				let nx = ObjMove_GetX(obj);
				let ny = ObjMove_GetY(obj);
				
				let dist = GetDistance(nx, ny, x, y);
				let nang = AngleToLocation(nx, ny, x, y);
				
				let mx = cos(nang);
				let my = sin(nang);
				
				ObjMove_SetSpeed(obj, 2);
				ObjMove_SetAngle(obj, nang);
				ascent(i in 0..bdure){
					let nmod = sin(90/bdure*i-90)+1;
					ObjMove_SetPosition(obj, nx+dist*mx*nmod, ny+dist*my*nmod);
					if(!Hold(1)){break;}
				}
				
				ObjMove_SetAcceleration(obj, 0);
				ObjMove_SetSpeed(obj, 0);
				
				
				
				if(implode <= 0){
					Obj_Delete(obj);
					return;
				}
				let onang = AngleToLocation(ox, oy, x, y);
				
				let nuke = CreateLargeNukeA1(x, y);
				ObjMove_SetSpeed(nuke, 8);
				ObjMove_SetAngle(nuke, onang);
				ObjMove_SetMaxSpeed(nuke, 0);
				ObjMove_SetAcceleration(nuke, -0.3);
				
				
				let tscl = 0.2;
				PlaySoundO2(se_don00, 60);
				Obj_SetValue(nuke, "NukeScale", tscl);
				if(!Hold(30)){}
				ascent(i in 0..60){
					Obj_SetValue(nuke, "NukeScale", tscl+tscl/15*i);
					if(!Hold(1)){break;}
				}
				
				
				loop(implode-10){
				
					if(!Hold(1)){break;}
				}
				
				ascent(i in 0..30){
					let bmod = round(60*sin(90/30*i));
					
					Obj_SetValue(nuke, "NukeAlpha", 255-92*(bmod%2));
					
					if(!Hold(2)){break;}
				}
				
				
				descent(i in 0..10){
					Obj_SetValue(nuke, "NukeScale", tscl/9*i);
					if(!Hold(1)){break;}
				}
				
				
				let r = 255;
				let g = 64;
				let b = 42;
				ExplosionA1(nuke, Obj_GetValueD(nuke, "NukeGraphic", "CHERRY"),
						[r, g, b],
						[r, g, b]);
				yield;
				
				nx = ObjMove_GetX(nuke);
				ny = ObjMove_GetY(nuke);
				
				if(EnemyDead || Obj_IsDeleted(nuke)){
					Obj_Delete(nuke);
					return;
				}
				Obj_Delete(nuke);
				
				PlaySoundO2(se_tan01, 40);
				let args = 0.3+argument/80;
				let argm = 3+round(argument/3);
				let argx = 1+floor(argument/30);
				
				ascent(o in 0..argx){
					ascent(i in 0..argm){
						let a = CreateObjShotA1(nx,ny,(0.25+args)*(1+o/2),ang+360/argm*i,83,25);
						ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
					}
				}
				
		}
	}
}


